//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  jAOf[VuV(TGPLinearGradientBrush)
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1119 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  protected
    procedure Paint; override;
  end;

  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    RadioGroup2: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel    : TMyPanel;
    FStartColor : TColor;
    FEndColor   : TColor;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  LinearGradatiBrush';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 160;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;
  end;

  FStartColor := clBlack;
  FEndColor   := clWhite;

  RadioGroup1.ItemIndex := 0;
  RadioGroup2.ItemIndex := 0;
end;

//=============================================================================
//  [JnF]{^
//  Of[V̊JnFݒ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := FStartColor;
  if ColorDialog1.Execute then begin
    FStartColor := ColorDialog1.Color;
  end;
  MyPanel.Invalidate;
end;

//=============================================================================
//  [IF]{^
//  Of[V̏IFݒ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  ColorDialog1.Color := ARGBToColorRef(FEndColor);
  if ColorDialog1.Execute then begin
    FEndColor := ColorDialog1.Color;
  end;
  MyPanel.Invalidate;
end;

//=============================================================================
//  RadioGroup1OnClickCxg
//  ύXMyPanelĕ`
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  MyPanel.Invalidate;
end;

//=============================================================================
//  CheckBox1OnClickCxg
//  ύXMyPanelĕ`
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic    : TGPGraphics;
  LStartColor   : TGPColor;
  LEndColor     : TGPColor;
  LGradientRect : TGPRectF;
  LCanvasRect   : TGPRectF;
  LGradientMode : TLinearGradientMode;
  LGPLinerBrush : TGPLinearGradientBrush;
begin
  inherited;

  //`
  //ۂɂ͌ȂĎɋ`܂͑ȉ~`悵Ă܂̂
  Canvas.Font.Name   := 'Arial';
  Canvas.Font.Style  := [fsBold];
  Canvas.Font.Height := -40;
  Canvas.TextOut(60, 70, 'Mr.XRAY');

  //RadioGroup̑IItemɂāCYOf[ṼIuWFNg𐶐
  LGradientMode := LinearGradientModeHorizontal;
  case Form1.RadioGroup1.ItemIndex of
    0 : LGradientMode := LinearGradientModeHorizontal;
    1 : LGradientMode := LinearGradientModeVertical;
    2 : LGradientMode := LinearGradientModeForwardDiagonal;
    3 : LGradientMode := LinearGradientModeBackwardDiagonal;
  end;

  LStartColor  := ColorRefToARGB(Form1.FStartColor);
  LEndColor    := ColorRefToARGB(Form1.FEndColor);

  //Of[ṼTCY(TGPRectF)ݒ
  if Form1.CheckBox1.Checked then begin
    LGradientRect := MakeRect(10.0, 10.0, 50.0, 50.0);
  end else begin
    LGradientRect := MakeRect(10.0, 10.0, 250.0, 250.0);
  end;
  //jAOf[ṼIuWFNg𐶐
  LGPLinerBrush := TGPLinearGradientBrush.Create(
                          LGradientRect,
                          LStartColor,
                          LEndColor,
                          LGradientMode);

  //TGPGrahics̃IuWFNg𐶐
  LGPGraphic  := TGPGraphics.Create(Canvas.Handle);

  //`̈̋`͈͂ݒ
  LCanvasRect := MakeRect(10.0, 10.0, 250.0, 250.0);
  //`s
  case Form1.RadioGroup2.ItemIndex of
    0: LGPGraphic.FillRectangle(LGPLinerBrush, LCanvasRect);
    1: LGPGraphic.FillEllipse(LGPLinerBrush, LCanvasRect);
  end;

  //CreateIuWFNg͉
  LGPLinerBrush.Free;
  LGPGraphic.Free;
end;

end.
